;*****************************************************************************
; Calculate sinus
; Zalozenia :
;   zdefiniowana tablica sinus ( dw )
;*****************************************************************************
NUMBER  EQU 256                         ; ile pozycji w tablicy
MULT    dw  30                          ; mnoznik tablicy sinusa
temp_s  dw 0
Calculate_sincos        Proc
        mov     edi, o sinus
        mov     ecx, NUMBER             ; ile pozycji w tablicy
        finit
pet_sin:
        mov     temp_s, NUMBER
        sub     temp_s, cx
        fldpi                           ; zaladuj PI na stos
        fimul   temp_s                  ; x * PI
        mov     temp_s, NUMBER / 2
        fidiv   temp_s                  ; ( x * PI ) / (NUMBER / 2)
        fsin                            ; sin( ( x * PI ) / ( NUMBER / 2 ) )
        mov     ax, MULT
        mov     temp_s, ax
        fimul   temp_s                  ; MULT * sin( (x*PI) / (NUMBER / 2))
        frndint                         ; zaokraglij do liczby calkowitej
        fistp   w temp_s
        mov     ax, temp_s              ; zapisz wynik do eax
        stosw                           ; zapamietaj w tablicy

        dec     ecx                     ; zmniejsz liczbe petli
        jnz     pet_sin

        ret
Calculate_sincos        EndP


;*****************************************************************************
; Wygenerowanie funkcji equalizera
;*****************************************************************************
temp_s2 dd 0
Calc_eq_sin     Proc
        mov     edi, o sin_eq
        mov     ecx, 318                ; ile pozycji w tablicy
        finit
eq_sin:
        mov     temp_s, 318
        sub     temp_s, cx
        fldpi                           ; zaladuj PI na stos
        fimul   temp_s                  ; x * PI
        fst     temp_s2
        mov     temp_s, 20
        fidiv   temp_s                  ; ( x * PI ) / 16
        fsin                            ; sin( ( x * PI ) / 16 )
        mov     temp_s, 10
        fimul   temp_s                  ; 10 * sin( ( x * PI ) / 16 )
        frndint                         ; zaokraglij do liczby calkowitej
        fistp   w temp_s
        mov     ax, temp_s              ; zapisz wynik do eax

        fld     temp_s2
        mov     temp_s, 80
        fidiv   temp_s                  ; ( x * PI ) / 64
        fsin                            ; sin( ( x * PI ) / 64 )
        mov     temp_s, 10
        fimul   temp_s                  ; 10 * sin( ( x * PI ) / 64 )
        frndint                         ; zaokraglij do liczby calkowitej
        fistp   w temp_s
        add     ax, temp_s              ; zapisz wynik do eax

        stosw                           ; zapamietaj w tablicy

        dec     ecx                     ; zmniejsz liczbe petli
        jnz     eq_sin

        ret
Calc_eq_sin     EndP
